#include "license.h" //gnu license details
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "/x/src/inc/bug.h"
#include "bitops.h"
#include "tabs.h"
#include "hshs.h"
#include "memi.h"
#include "memb.h"
typedef struct _range
{
	int strt;
	int cnt;
}RANGE;
int *pinds;
char *chrs;
unsigned char *hdat;
int bas[3];
int *hlnks;
int lind;
int hind;
int len,sed;
int cnts[MAX][LETS];
int refs[MAX][LETS];
RANGE rngs[MAX];
long maps[MAX];
int lev=0;
int chrlen;
int byts;
//bug
bool bflg=0;
int bcnt=0;
void bk()
{
	asm("nop");
}
void shostr(int ind)
{
	char buf[MAX+2];
	int ine,lim,loc=0;
	ine=pinds[ind];
	lim=ine+MAX;
	memset(buf,0,MAX+2);
	while(ine<lim)
	{
		if(!chrs[ine])
		{
			buf[loc]=0;
			psr(buf);
			return;
		}
		buf[loc++]=lets[chrs[ine]];
		buf[loc]=0;
		ine++;
	}
	buf[MAX+1]=0;
	psr(buf);
}
void sho(int strt,int cnt)
{
	int ind;
	for(ind=strt;ind<strt+cnt;ind++)
	{
		pib(ind);
		shostr(ind);
	}
}
void shocod(int ind)
{
	char *pchr=&chrs[pinds[ind]];
	while(*pchr)
	{
		printf("%d,",*pchr);
		pchr++;
	}
	pr();
}
void shocodx(char *pchr)
{
	while(*pchr)
	{
		printf("%d,",*pchr);
		pchr++;
	}
	pr();
}
void shocods(int strt,int cnt)
{
	int lim=strt+cnt;
	int ind;
	for(ind=strt;ind<lim;ind++)
		shocod(ind);
}
//endbug
char let2cod(char let)
{
	if(let>=0x7b)
		return -1;
	return unlets[let];
}
void psg()
{
	srand(sed);
	int ind,ine,slen;
	int loc=0;
	int min=MAX>>2;
	int rng=MAX-min;
	for(ind=0;ind<len;ind++)
	{
		pinds[ind]=loc;
		slen=rand()%rng+min;
		for(ine=0;ine<slen;ine++)
			chrs[loc++]=(rand()%LTS)+1;
		chrs[loc++]=0;
	}
	chrlen=loc;
}
void dused()
{
//	srand(time(0));
//	sed=rand();
	sed=SED;
}
void hsrt()
{
	int *pcnt=cnts[lev];
	int *pref=refs[lev];
	int cntsx[LETS];
	int refsx[LETS];
	long map=0;
	int *pdat=&pinds[rngs[lev].strt];
	int ind,cnt;
	char *pchr,chr;
	for(ind=0;ind<rngs[lev].cnt;ind++)
	{
		chr=chrs[pdat[ind]+lev];
		if(test_and_set_bit(chr,(long*)&map))
			cntsx[chr]++;
		else
			cntsx[chr]=1;
	}
	maps[lev]=map;
	int loc=cnt=0;
	while(1)
	{
		ind=scanbit(map,99);
		if(ind==99)
			break;
		refsx[ind]=refs[lev][ind]=loc;
		clear_bit(ind,&map);
		loc+=cntsx[ind];
		cnts[lev][ind]=cntsx[ind];
		cnt++;
	}
	if(cnt<2)
		return;
	map=maps[lev];
	int eind=scanbit(map,99);
	int tmp1,tmp0=pdat[refsx[eind]];
	int *pint,nind,slen;
	for(ind=0;ind<rngs[lev].cnt;ind++)
	{
		nind=chrs[tmp0+lev];
		if(eind==nind)
		{
			pdat[refsx[eind]++]=tmp0;
			cntsx[eind]--;
			if(!cntsx[eind])
			{
				clear_bit(eind,&map);
				eind=scanbit(map,99);
			}
			tmp0=pdat[refsx[eind]];
		}
		else
		{
			pint=&pdat[refsx[nind]++];
			tmp1=*pint;
			*pint=tmp0;
			cntsx[nind]--;
			if(!cntsx[nind])
				clear_bit(nind,&map);
			tmp0=tmp1;
		}
	}
}
void dufs()
{
	int ind=scanbit(maps[lev],99);
	int cnt;
	if(ind==99)
	{
		lev--;
		while(rngs[lev-1].cnt==rngs[lev].cnt)
			lev--;
		return;
	}
	else
	{
		cnt=cnts[lev][ind];
		if(!ind)
		{
			clear_bit(ind,&maps[lev]);
			return;
		}
		if(cnt==1)
		{
			clear_bit(ind,&maps[lev]);
			return;
		}
		rngs[lev+1].strt=refs[lev][ind]+rngs[lev].strt;
		rngs[lev+1].cnt=cnts[lev][ind];
		lev++;
		hsrt();
		clear_bit(ind,&maps[lev-1]);
	}
}
void srts()
{
	rngs[0].strt=0;
	rngs[0].cnt=len;
	lev=0;
	hsrt();
	while(1)
	{
		dufs();
		if(lev<0)
			return;
	}
}
void chksrt()
{
	int ind;
	char *prev,*pcur;
	for(ind=1;ind<len;ind++)
	{
		prev=&chrs[pinds[ind-1]];
		pcur=&chrs[pinds[ind]];
		if(strcmp(pcur,prev)<0)
		{
			psb((char*)"sort error");
			pib(ind-1);
			shostr(ind-1);
			pib(ind);
			shostr(ind);
			return;
		}
	}
	psr((char*)"sort ok");
}
int uniq()
{
	char* prv=&chrs[pinds[0]];
	char* pcur;
	int ind,ine=1;
	for(ind=1;ind<len;ind++)
	{
		pcur=&chrs[pinds[ind]];
		if(strcmp(prv,pcur))
		{
			pinds[ine++]=pinds[ind];
			prv=pcur;
		}
	}
}
int uniqcnt()
{
	int ind,sum=0;
	for(ind=0;ind<len;ind++)
		sum+=strlen(&chrs[pinds[ind]]);
	return sum;
}
int cmp(const void *p0,const void *p1)
{
	return strcmp(&chrs[*(int*)p0],&chrs[*(int*)p1]);
}
void prtim(long tim)
{
	printf("%.4f\n",(double)tim/CLOCKS_PER_SEC);
}
void hsh()
{
	int tmp=len;
	int siz=1;
	int byts=0;
	while(tmp/siz>THR)
	{
		siz*=LETS;
		bas[byts]=siz;
		byts++;
	}
	int hcnts[siz];
	memset(hcnts,0,siz*sizeof(int));
	int hrefs[siz+1];
	int ind,cnt,tbyts;
	char *pchr;
	switch(byts)
	{
		case 1:
		{
			for(ind=0;ind<len;ind++)
				hcnts[chrs[pinds[ind]]]++;
		}
		break;
		case 2:
		{
			for(ind=0;ind<len;ind++)
			{
				pchr=&chrs[pinds[ind]];
				hcnts[*pchr*LETS+pchr[1]]++;
			}
		}
		break;
		default:
		{
			for(ind=0;ind<len;ind++)
			{
				pchr=&chrs[pinds[ind]];
				hcnts[*pchr*LETS2+pchr[1]*LETS+pchr[2]]++;
			}
		}
		break;
	}
	int loc=0;
	for(ind=0;ind<siz;ind++)
	{
		hrefs[ind]=loc;
		loc+=hcnts[ind];
	}
	hrefs[ind]=loc;
	memset(hdat,0,(siz)*sizeof(int));
	hdat[0]=byts;
	hlnks=(int*)&hdat[4];
	int lind=0;
	hind=(siz+1)*sizeof(int);
	memi onds;
	memb obs;
	int *pint;
	int strt,ine,ac=0,hstrt;
	switch(byts)
	{
		case 1:
			hstrt=0;
		break;
		case 2:
		case 3:
			hstrt=LETS;
		break;
	}
	for(ind=hstrt;ind<siz;ind++)
	{
		cnt=hcnts[ind];
		if(cnt)
		{
			hlnks[lind++]=hind;
			strt=hrefs[ind];
			cnt=hcnts[ind];
			onds.ind=0;
			obs.ind=0;
			for(ine=0;ine<cnt;ine++)
			{
				onds.rit(obs.ind);
				pchr=&chrs[pinds[strt]];
				pchr+=byts;
				while(*pchr)
				{
					obs.rit(*pchr);
					pchr++;
				}
				obs.rit(0);
				strt++;
			}
			tbyts=scanbitr(obs.ind,99)/8+1;
			*(int*)&hdat[hind]=ac;
			hind+=sizeof(int);
			ac+=cnt;
			switch(tbyts)
			{
				case 1:
				{
					hdat[hind++]=tbyts;
					hdat[hind++]=onds.ind;
					for(ine=0;ine<onds.ind;ine++)
						hdat[hind++]=(char)onds.buf[ine];
				}
				break;
				case 2:
				{
					hdat[hind++]=tbyts;
					*(short*)&hdat[hind]=onds.ind;
					hind+=2;
					for(ine=0;ine<onds.ind;ine++)
					{
						*(short*)&hdat[hind]=onds.buf[ine];
						hind+=2;
					}
				}
				break;
				default:
					px();
			}
			memcpy(&hdat[hind],obs.buf,obs.ind);
			hind+=obs.ind;
		}
		else
			hlnks[lind++]=-1;
	}
}
int in(char *trg,int strt,int fin)
{
	if(strt<0)
		return 0;
	int ac=*(int*)&hdat[strt];
	strt+=sizeof(int);
	int tbyts=hdat[strt++];
	int hi,lo,ref,tlen,leno,res;
	char *pstrs;
	unsigned char *pofs;
	short *sofs;
	switch(tbyts)
	{
		case 1:
		{
			lo=0;
			hi=hdat[strt++];
			ref=hi>>1;
			pofs=&hdat[strt];
			pstrs=(char*)&hdat[strt+hi];
			while(hi-lo>3)
			{
				res=strcmp(trg,&pstrs[pofs[ref]]);
				if(!res)
						return ac+ref;
				if(res>0)
					lo=ref;
				else
					hi=ref;
				ref=((hi-lo)>>1)+lo;
			}
			while(lo<hi)
			{
				if(!strcmp(trg,&pstrs[pofs[lo]]))
					return ac+lo;
				lo++;
			}
			return -1;
		}
		break;
		case 2:
		{
			lo=0;
			hi=*(short*)&hdat[strt];
			strt+=2;
			ref=hi>>1;
			sofs=(short*)&hdat[strt];
			pstrs=(char*)&hdat[strt+(hi<<1)];
			while(hi-lo>3)
			{
				res=strcmp(trg,&pstrs[sofs[ref]]);
				if(!res)
						return ac+ref;
				if(res>0)
					lo=ref;
				else
					hi=ref;
				ref=((hi-lo)>>1)+lo;
			}
			while(lo<hi)
			{
				if(!strcmp(trg,&pstrs[sofs[lo]]))
					return ac+lo;
				lo++;
			}
			return -1;
		}
		break;
	}
}
void chkhsh()
{
	hlnks=(int*)&hdat[4];
	int ind,val,sel;
	char *trg;
	char trgx[MAX+2];
	switch(*hdat)
	{
		case 1:
		{
			for(ind=0;ind<len;ind++)
			{
				trg=&chrs[pinds[ind]];
				sel=*trg;
				val=in(&trg[1],hlnks[sel],hlnks[sel+1]);
				if(val==ind)
				{
					strcpy(trgx,&chrs[pinds[ind+1]]);
					trgx[3]++;
					if(trg[3]!=trgx[3])
					{
						if(in(&trgx[1],hlnks[sel],hlnks[sel+1])>=0)
						{
							psb((char*)"hash check false pos");
							pib(ind);
							shocodx(trgx);
							exit(2);
						}
					}
				}
				else
				{
					psb((char*)"hash check not found");
					pir(ind);
					exit(1);
				}
			}
			psr((char*)"hash check ok");
		}
		break;
		case 2:
		{
			for(ind=0;ind<len;ind++)
			{
				trg=&chrs[pinds[ind]];
				sel=*trg*LETS+trg[1]-LETS;
				val=in(&trg[2],hlnks[sel],hlnks[sel+1]);
				if(val==ind)
				{
					strcpy(trgx,&chrs[pinds[ind+1]]);
					trgx[4]++;
					if(trg[4]!=trgx[4])
					{
						if(in(&trgx[2],hlnks[sel],hlnks[sel+1])>=0)
						{
							psb((char*)"hash check false positive");
							pib(ind);
							shocodx(trgx);
							exit(2);
						}
					}
				}
				else
				{
					psb((char*)"hash check not found");
					pir(ind);
					exit(1);
				}
			}
			psr((char*)"hash check ok");
		}
		break;
		case 3:
		{
			for(ind=0;ind<len;ind++)
			{
				trg=&chrs[pinds[ind]];
				sel=*trg*LETS2+trg[1]*LETS+trg[2]-LETS;
				val=in(&trg[3],hlnks[sel],hlnks[sel+1]);
				if(val==ind)
				{
					strcpy(trgx,&chrs[pinds[ind+1]]);
					trgx[4]++;
					if(trg[4]!=trgx[4])
					{
						if(in(&trgx[2],hlnks[sel],hlnks[sel+1])>=0)
						{
							psb((char*)"hash check false pos");
							pib(ind);
							shocodx(trgx);
							exit(2);
						}
					}
				}
				else
				{
					psb((char*)"hash check not found");
					pir(ind);
					exit(1);
				}
			}
			psr((char*)"hash check ok");
		}
		break;
	}
}
int main(int argc, char* argv[])
{
	long tim0,tim1;
	len=atoi(argv[1]);
	if(len<1000)
	{
		psr((char*)"argument must be 1000 or greater");
		exit(0);
	}
	psb((char*)"strings");
	pir(len);
	dused();
	pinds=new int[len];
	chrs=new char[len*24];
	hdat=new unsigned char[len*24];
	psg();
	psb((char*)"characters");
	pir(chrlen);
	tim0=clock();
	srts();
	tim1=clock();
	psb((char*)"count sort time");
	prtim(tim1-tim0);
	psb((char*)"count");
	chksrt();
	len=uniq();
	psb((char*)"unique strings");
	pir(len);
	psb((char*)"characters in unique strings");
	int uchrs=uniqcnt();
	pir(uchrs);
	psb((char*)"data size");
	int dsiz=uchrs+len*4;
	pir(dsiz);
	tim0=clock();
	hsh();
	tim1=clock();
	psb((char*)"hash time");
	prtim(tim1-tim0);
	psb((char*)"hash bytes");
	pir(hind);
	psb((char*)"compression");
	pfr((double)hind/dsiz);
	tim0=clock();
	chkhsh();
	tim1=clock();
	psb((char*)"hash check time");
	prtim(tim1-tim0);
	psg();
	tim0=clock();
	qsort(pinds,len,4,cmp);
	tim1=clock();
	psb((char*)"quick sort time");
	prtim(tim1-tim0);
	psb((char*)"quick");
	chksrt();
}

